	.model	tiny
	.code
	include	MDABIOS.I
	org	100h

;NEVER	equ	1

FMT	equ	128	;Write argument

FMTStringZ	equ	FMT+0  ;string Z, arg=W/offs,W/seg
FMTStringD	equ	FMT+1  ;string $, arg=W/offs,W/seg
FMTHByte	equ	FMT+2  ;hex arg=B/byte
FMTHWord	equ	FMT+3  ;hex arg=W/word
FMTHLong	equ	FMT+4  ;hex arg=W/higher, W/lower
FMTAddr	equ	FMT+5  ;hex arg=W/seg, W/offs
FMTDByte	equ	FMT+6  ;dec arg=B/byte
FMTDWord	equ	FMT+7  ;dec arg=W/word
FMTDLong	equ	FMT+8  ;dec arg=W/higher, W/lower
FMTFCB	equ	FMT+9  ;arg=W/offs,W/seg of FCB
FMTOChar	equ	FMT+10 ;follows offset, arg=offseted
FMTTableW	equ	FMT+11 ;W/reg, W/offset of tab
FMTTableB	equ	FMT+12 ;B/reg, W/offset of tab
FMTUnused	equ	FMT+13

REG_AX	equ	0
REG_AL	equ	REG_AX
REG_AH	equ	REG_AX+1
REG_BX	equ	2
REG_BL	equ	REG_BX
REG_BH	equ	REG_BX+1
REG_CX	equ	4
REG_CL	equ	REG_CX
REG_CH	equ	REG_CX+1
REG_DX	equ	6
REG_DL	equ	REG_DX
REG_DH	equ	REG_DX+1
REG_SI	equ	8
REG_DI	equ	10
REG_BP	equ	12
REG_SP	equ	14
REG_DS	equ	16
REG_ES	equ	18
REG_SS	equ	20
REG_F	equ	22
REG_Size	equ	24

StoreAll	macro
	pushf
	push	ss
	push	es
	push	ds
	push	sp
	push	bp
	push	di
	push	si
	push	dx
	push	cx
	push	bx
	push	ax
	mov	bp,sp
	add	word ptr [bp+REG_SP],REG_Size-(REG_SP+2)
	cld
	push	cs
	pop	ds
	endm

RestoreAll	macro
	pop	ax
	pop	bx
	pop	cx
	pop	dx
	pop	si
	pop	di
	pop	bp
	inc	sp
	inc	sp
	pop	ds
	pop	es
	endm

Start:	cld
	jmp	Install

Jump21:
	cmp	ax,0EFA8h
	jne	NoEFA8
	mov	ax,0DEADh
	push	cs
	pop	ds
	iret

NoEFA8:
	StoreAll

	ifdef	NEVER
	mov	dl,'s'
	call	WriteChar
	mov	al,[bp+REG_AH]
	mov	byte ptr [SavePtr],al
	call	IHByte
	jmp	SKIP1
	mov	ah,[bp+REG_AH]
	endif

	lea	si,DscTable
NextDsc:	lodsb
	cmp	ah,al
	je	GotCmpEq
	inc	si
	inc	si
	inc	al
	jnz	NextDsc
	xor	si,si

	RestoreAll
	inc	sp
	inc	sp
	popf
	jmp	dword ptr cs:[OrigVect]

GotCmpEq:
	lodsw
	mov	si,ax
	mov	dl,MDAPSPID
	mov	ax,MDAPutChar
	int	10h
	mov	dx,si
	mov	ax,MDAStringZ
	int	10h
FndEDsc:	lodsb
	and	al,al
	jnz	FndEDsc
	mov	dl,'('
	call	WriteChar
	call	WriteDoFmt
	mov	dl,')'
	call	WriteChar
;	mov	dl,MDANL
;	mov	ax,MDAPutChar
;	int	10h

	mov	word ptr [SavePtr],si

SKIP1:

	RestoreAll
	inc	sp
	inc	sp
	popf


;	jmp	dword ptr cs:[OrigVect]

	pushf
	call	dword ptr cs:[OrigVect]

	StoreAll

	ifdef	NEVER
	mov	dl,'e'
	call	WriteChar
	mov	al,byte ptr [SavePtr]
	call	IHByte
	jmp	GoOut
	endif

	mov	si,word ptr [SavePtr]
	and	si,si
	jz	GoOut
	mov	dl,'='
	call	WriteChar
	test	byte ptr [bp+REG_F],1
	jz	NormalOut
	lea	si,DscERROR
NormalOut:	call	WriteDoFmt
	mov	dl,MDANL
	mov	ax,MDAPutChar
	int	10h

GoOut:
;	mov	ax,[bp+REG_F]
;	mov	[bp+REG_Size+4],ax

	RestoreAll

	inc	sp
	inc	sp
	popf
	retf	2

;	add	sp,4
;	iret

Return1:	ret

WriteDoFmt:	lodsb
	and	al,al
	jz	Return1
	cmp	al,FMT
	jc	WDF_PutIt
	cmp	al,FMTUnused
	jc	WDF_DoFmt
WDF_PutIt:	mov	dl,al
	mov	ax,MDAPutChar
	int	10h
	jmp	WriteDoFmt

WDF_DoFmt:	sub	al,FMT
	mov	bx,ax
	xor	bh,bh
	add	bx,bx
	call	word ptr [FmtTable+bx]
	jmp	WriteDoFmt

FmtTable:
	dw	offset FStringZ
	dw	offset FStringD
	dw	offset FHByte
	dw	offset FHWord
	dw	offset FHLong
	dw	offset FAddr
	dw	offset FDByte
	dw	offset FDWord
	dw	offset FDLong
	dw	offset FFCB
	dw	offset FOChar
	dw	offset FTableW
	dw	offset FTableB

FStringZ:	xor	cl,cl
	jmp	FStringAny

FStringD:	mov	cl,'$'
FStringAny:	mov	dl,'"'
	call	WriteChar
	xor	ah,ah
	lodsb
	mov	di,ax
	mov	bx,[bp+di]
	lodsb
	mov	di,ax
	push	si
	mov	si,[bp+di]
	mov	ds,bx
FSA_Loop:	lodsb
	cmp	al,cl
	jz	FSA_Term
	mov	dl,al
	call	QuoteChar
	jmp	FSA_Loop

FSA_Term:	pop	si
	push	cs
	pop	ds
	mov	dl,'"'
WriteChar:	mov	ax,MDAWriteChar
	int	10h
	ret


QuoteChar:	cmp	dl,32
	jnc	WriteChar
	push	dx
	mov	dl,'\'
	call	WriteChar
	mov	dl,'x'
	call	WriteChar
	pop	ax
IHByte:	push	cx
	mov	cl,4
	ror	al,cl
	call	IHNibble
	ror	al,cl
	pop	cx
IHNibble:	push	ax
	and	al,0Fh
	cmp	al,0Ah
	jc	IHN_Low
	add	al,'A'-('9'+1)
IHN_Low:	add	al,'0'
	push	dx
	mov	dl,al
	call	WriteChar
	pop	dx
	pop	ax
	ret

FHByte:	mov	dl,'$'
	call	WriteChar
	xor	ah,ah
	lodsb
	mov	di,ax
	mov	al,[bp+di]
	jmp	IHByte

FHWord:	mov	dl,'$'
IHWordGetW:	call	WriteChar
IHWordGet:	xor	ah,ah
	lodsb
	mov	di,ax
	mov	ax,[bp+di]
IHWord:	xchg	ah,al
	call	IHByte
	xchg	ah,al
	jmp	IHByte

FHLong:	call	FHWord
	jmp	IHWordGet

FAddr:	mov	dl,'*'
	call	IHWordGetW
	mov	dl,':'
	jmp	IHWordGetW

FTableB:	xor	ah,ah
	lodsb
	mov	di,ax
	mov	al,[bp+di]
	mov	bx,ax
	jmp	ITableWB

FTableW:	xor	ah,ah
	lodsb
	mov	di,ax
	mov	bx,[bp+di]
ITableWB:	lodsw
	push	si
	mov	si,ax
FTW_NextChunk:	lodsw
	cmp	bx,ax
	jc	FTW_Unknown
	mov	cx,ax
	lodsw
	and	ax,ax
	jnz	FTW_NotTerm
	cmp	cx,1
	jz	FTW_Unknown
FTW_NotTerm:	mov	dx,ax
;BX=Code, CX=Low, DX=High
FTW_NextString:	cmp	bx,cx
	jz	FTW_GotIt
	inc	cx
FTW_EndStr:	lodsb
	and	al,al
	jnz	FTW_EndStr
	cmp	dx,cx
	jc	FTW_NextChunk
	jmp	FTW_NextString

FTW_Unknown:	lea	si,UnkString
FTW_GotIt:	mov	dx,si
	pop	si
	mov	ax,MDAStringZ
	int	10h
	ret

FOChar:	mov	dl,'`'
	call	WriteChar
	xor	ah,ah
	lodsb
	mov	di,ax
	mov	ah,[bp+di]
	lodsb
	add	al,ah
	mov	dl,al
	call	WriteChar
	mov	dl,''''
	jmp	WriteChar


FFCB:	ret

FDByte:	xor	ah,ah
	lodsb
	mov	di,ax
	mov	bl,[bp+di]
	xor	bh,bh
	xor	dx,dx
	lea	cx,DecPwrsB
	jmp	IDL_LongI

FDWord:	xor	ah,ah
	xor	dx,dx
	lea	cx,DecPwrsW
	jmp	IDWordI

FDLong:	xor	ah,ah
	lodsb
	mov	di,ax
	mov	dx,[bp+di]
	lea	cx,DecPwrsL
IDWordI:	lodsb
	mov	di,ax
	mov	bx,[bp+di]
;Num=DX:BX, div=AX:CX
IDL_LongI:
;	int	3
	push	si
	mov	si,cx
IDL_DigLoop0:	push	si
IDL_DigLoop:	lodsw
	mov	cx,ax
	lodsw
	push	bp
	xor	bp,bp
IDL_SubLoop:	inc	bp
	sub	bx,cx
	sbb	dx,ax
	jnc	IDL_SubLoop
	add	bx,cx
	adc	dx,ax
	mov	cx,'0'-1
	add	cx,bp
	pop	bp
	pop	ax
	cmp	cl,'0'
	jnz	IDL_DoIt
	cmp	si,offset DecPwrsE
	je	IDL_DoIt2
	jmp	IDL_DigLoop0

IDL_DoIt:	xor	ax,ax
IDL_DoIt2:	push	ax
	push	dx
	mov	dx,cx
	call	WriteChar
	pop	dx
	cmp	si,offset DecPwrsE
	jne	IDL_DigLoop
IDL_Return:	pop	si
	pop	si
	ret

DecPwrsL:	dd	1000000000
	dd	100000000
	dd	10000000
	dd	1000000
	dd	100000
DecPwrsW:	dd	10000
	dd	1000
DecPwrsB:	dd	100
	dd	10
	dd	1
DecPwrsE:

;!!! Please don't uncomment DscClose and DscExec calls!
;!!! It hangs the machine and I have no clue why.
;!!! I tried a lot of hacks but no one made it working.
;!!! Please contact me if you know how to fix it.
DscTable:
	db	03Ch
	dw	offset DscCreate
	db	03Dh
	dw	offset DscOpen
;	db	03Eh
;	dw	offset DscClose
	db	03Fh
	dw	offset DscRead
	db	040h
	dw	offset DscWrite
	db	041h
	dw	offset DscDelete
	db	042h
	dw	offset DscLSeek
	db	043h
	dw	offset DscChMod
;	db	04Bh
;	dw	offset DscExec
	db	059h
	dw	offset DscErrInfo
	db	05Ah
	dw	offset DscCreateUniq
	db	05Bh
	dw	offset DscCreateNew
	db	0FFh

DscCreate:	db	'Create',MDAZ
	db	FMTStringZ,REG_DS,REG_DX,','
	db	FMTHWord,REG_CX,MDAZ
	db	FMTDWord,REG_AX,MDAZ

DscOpen:	db	'Open',MDAZ
	db	FMTStringZ,REG_DS,REG_DX,','
	db	FMTHByte,REG_AL,MDAZ
	db	FMTDWord,REG_AX,MDAZ

DscClose:	db	'Close',MDAZ
	db	FMTHWord,REG_BX,MDAZ
	db	'OK',MDAZ

DscRead:	db	'Read',MDAZ
	db	FMTDWord,REG_BX,','
	db	FMTAddr,REG_DS,REG_DX,','
	db	FMTDWord,REG_CX,MDAZ
	db	FMTDWord,REG_AX,MDAZ

DscWrite:	db	'Write',MDAZ
	db	FMTDWord,REG_BX,','
	db	FMTAddr,REG_DS,REG_DX,','
	db	FMTDWord,REG_CX,MDAZ
	db	FMTDWord,REG_AX,MDAZ

DscDelete:	db	'Delete',MDAZ
	db	FMTStringZ,REG_DS,REG_DX,MDAZ
	db	'OK',MDAZ

DscLSeek:	db	'LSeek',MDAZ
	db	FMTDWord,REG_BX,','
	db	FMTTableB,REG_AL
	dw	offset TabLSeek
	db	','
	db	FMTDLong,REG_CX,REG_DX,MDAZ ;sign!
	db	FMTDLong,REG_DX,REG_AX,MDAZ

TabLSeek:	dw	0,2
	db	'SET',MDAZ
	db	'CUR',MDAZ
	db	'END',MDAZ

	dw	1,0

DscChMod:	db	'CHMOD',MDAZ
	db	FMTTableB,REG_AL
	dw	offset TabChMod
	db	','
	db	FMTStringZ,REG_DS,REG_DX,','
	db	FMTHWord,REG_CX,MDAZ
	db	FMTHWord,REG_CX,MDAZ

TabChMod:	dw	0,1
	db	'get',MDAZ
	db	'set',MDAZ

	dw	1,0

DscExec:	db	'Exec',MDAZ
	db	FMTStringZ,REG_DS,REG_DX,','
	db	FMTAddr,REG_ES,REG_BX,','
	db	FMTTableB,REG_AL
	dw	offset TabExec
	db	MDAZ
	db	'OK',MDAZ

TabExec:	dw	0,0
	db	'exec prg',MDAZ

	dw	3,3
	db	'load ovl',MDAZ

	dw	1,0

DscErrInfo:	db	'ErrorInfo',MDAZ
	db	FMTDWord,REG_BX,MDAZ
	db	'ext=',FMTDWord,REG_AX,','
	db	'class=',FMTDByte,REG_BH,','
	db	'action=',FMTDByte,REG_BL,','
	db	'locus=',FMTDByte,REG_CH,MDAZ

DscCreateUniq:	db	'CreateUniq',MDAZ
	db	FMTStringZ,REG_DS,REG_DX,','
	db	FMTHWord,REG_CX,MDAZ
	db	FMTStringZ,REG_DS,REG_DX,','
	dw	FMTDWord,REG_AX,MDAZ

DscCreateNew:	db	'CreateNew',MDAZ
	db	FMTStringZ,REG_DS,REG_DX,','
	db	FMTHWord,REG_CX,MDAZ
	db	FMTDWord,REG_AX,MDAZ

DscERROR:	db	'E:',FMTHWord,REG_AX,'>'
	db	FMTTableW,REG_AX
	dw	offset TabERROR
	db	MDAZ

TabERROR:	dw	0,13
	db	'no error',MDAZ
	db	'function number invalid',MDAZ
	db	'file not found',MDAZ
	db	'path not found',MDAZ
	db	'too many open files (no handles available)',MDAZ
	db	'access denied',MDAZ
	db	'invalid handle',MDAZ
	db	'memory control block destroyed',MDAZ
	db	'insufficient memory',MDAZ
	db	'memory block address invalid',MDAZ
	db	'environment invalid (usually >32K in length)',MDAZ
	db	'format invalid',MDAZ
	db	'access code invalid',MDAZ
	db	'data invalid',MDAZ

	dw	15,39
	db	'invalid drive',MDAZ
	db	'attempted to remove current directory',MDAZ
	db	'not same device',MDAZ
	db	'no more files',MDAZ
	db	'disk write-protected',MDAZ
	db	'unknown unit',MDAZ
	db	'drive not ready',MDAZ
	db	'unknown command',MDAZ
	db	'data error (CRC)',MDAZ
	db	'bad request structure length',MDAZ
	db	'seek error',MDAZ
	db	'unknown media type (non-DOS disk)',MDAZ
	db	'sector not found',MDAZ
	db	'printer out of paper',MDAZ
	db	'write fault',MDAZ
	db	'read fault',MDAZ
	db	'general failure',MDAZ
	db	'sharing violation',MDAZ
	db	'lock violation',MDAZ
	db	'disk change invalid',MDAZ
	db	'FCB unavailable',MDAZ
	db	'sharing buffer overflow',MDAZ
	db	'code page mismatch',MDAZ
	db	'cannot complete file operation (out of input)',MDAZ
	db	'insufficient disk space',MDAZ

	dw	50,78
	db	'network request not supported',MDAZ
	db	'remote computer not listening',MDAZ
	db	'duplicate name on network',MDAZ
	db	'network name not found',MDAZ
	db	'network busy',MDAZ
	db	'network device no longer exists',MDAZ
	db	'network BIOS command limit exceeded',MDAZ
	db	'network adapter hardware error',MDAZ
	db	'incorrect response from network',MDAZ
	db	'unexpected network error',MDAZ
	db	'incompatible remote adapter',MDAZ
	db	'print queue full',MDAZ
	db	'queue not full',MDAZ
	db	'not enough space to print file',MDAZ
	db	'network name was deleted',MDAZ
	db	'network: Access denied',MDAZ
	db	'network device type incorrect',MDAZ
	db	'network name not found',MDAZ
	db	'network name limit exceeded',MDAZ
	db	'network BIOS session limit exceeded',MDAZ
	db	'temporarily paused',MDAZ
	db	'network request not accepted',MDAZ
	db	'network print/disk redirection paused',MDAZ
	db	'network software not installed',MDAZ
	db	'unexpected adapter close',MDAZ
	db	'password expired',MDAZ
	db	'login attempt invalid at this time',MDAZ
	db	'disk limit exceeded on network node',MDAZ
	db	'not logged in to network node',MDAZ

	dw	80,80
	db	'file exists',MDAZ

	dw	82,90
	db	'cannot make directory',MDAZ
	db	'fail on INT 24h',MDAZ
	db	'too many redirections',MDAZ
	db	'duplicate redirection',MDAZ
	db	'invalid password',MDAZ
	db	'invalid parameter',MDAZ
	db	'network write fault',MDAZ
	db	'function not supported on network',MDAZ
	db	'required system component not installed',MDAZ

	dw	100,104
	db	'unknown error',MDAZ
	db	'not ready',MDAZ
	db	'EMS memory no longer valid',MDAZ
	db	'not High Sierra or ISO-9660 format',MDAZ
	db	'door open',MDAZ

	dw	1,0

UnkString:	db	'???',MDAZ

OrigVect:	org	$+4
SavePtr:	org	$+2
EndRes:
	org	OrigVect
Install:        lea	dx,BannerM
	call	Print

	mov	ax,0EFA8h
	int	21h
	cmp	ax,0DEADh
	jne	NewInst
	mov	ax,3521h
	int	21h
	mov	ax,es
	push	ds
	pop	cx
	cmp	ax,cx
	jne	BadVect
	cmp	bx,offset Jump21
	je	GoodVect
BadVect:	lea	dx,BadVectM
BadBailOut:	call	Print
	mov	ax,4C0Ah
	int	21h

GoodVect:	mov	ax,2521h
	lds	dx,dword ptr [OrigVect]
	int	21h
	mov	ax,es
	dec	ax
	mov	ds,ax
	push	cs
	pop	ax
	mov	word ptr ds:[1],ax
	mov	ah,49h
	int	21h	;Free
	mov	ax,MDAModUseCnt
	mov	dx,-1
	int	10h
	mov	ax,MDAStringZ
	lea	dx,MDeInstM
	push	cs
	pop	ds
	int	10h
	lea	dx,GoodVectM
	jmp	Print

NewInst:
	mov	ax,MDACheckInst
	int	10h
	cmp	ax,MDAInstMagic
	je	GotMDA
	lea	dx,NoMDAM
	jmp	Print

GotMDA:	mov	ax,MDAModUseCnt
	mov	dx,1
	int	10h
	mov	ax,MDAStringZ
	lea	dx,MInstM
	int	10h
	mov	ax,word ptr ds:[2Ch]
	mov	es,ax
	mov	ah,49h
	int	21h	;Free
	mov	word ptr ds:[2Ch],0
	lea	dx,NewInstM
	call	Print
	mov	ax,3521h
	int	21h
	lea	di,OrigVect
	mov	ax,es
	xchg	ax,bx
	push	ds
	pop	es
	stosw
	mov	ax,bx
	stosw
	lea	dx,Jump21
	mov	ax,2521h
	int	21h
	mov	dx,(offset EndRes-offset Start+10Fh)/16
	mov	ax,3100h
	int	21h

Print:	push	cs
	pop	ds
	mov	ah,9
	int	21h
	ret

BannerM:	db	'DOS File I/O Watcher v0.99',13,10
	db	' - by Jan Kratochvil <short@ucw.cz> in 1997',13,10,13,10,'$'
NewInstM:	db	'Resident part installed and watching...',13,10,'$'
BadVectM:	db	'Cannot flush&deinstall, vectors stolen!',13,10,'$'
GoodVectM:	db	'Successful deinstallation.',13,10,'$'
NoMDAM:	db	'MDA BIOS not found - install MDABIOS.COM!',13,10,'$'
MInstM:	db	MDAPSPID,'Installed.',MDANL,MDAZ
MDeInstM:	db	MDAPSPID,'Deinstalled.',MDANL,MDAZ
	end	Start


	pushf
	call	dword ptr cs:[OrigVect]
	pushf
	push	ax
	push	bp
	mov	bp,sp
	mov	ax,[bp+4]
	mov	[bp+10],ax
	pop	bp
	pop	ax
	inc	sp
	inc	sp
	iret


