	.model	tiny
	.code
	include	MDABIOS.I
	org	100h

	ifndef	USEVGA
VSEG	equ	0B000h
	else
VSEG	equ	0B800h
	endif

Start:	jmp	Install
	org	104h
	dw	08800h,Strategy-Start,Interrupt-Start
	db	'MDA$    '

Strategy:
	mov	word ptr cs:[ReqAddr],bx
	mov	word ptr cs:[ReqAddr+2],es
	retf

Interrupt:
	push	es
	push	ds
	push	bp
	push	si
	push	di
	push	dx
	push	cx
	push	bx
	push	ax

	push	cs
	pop	ds
	les	bx,dword ptr [ReqAddr]
	mov	al,es:[bx+2]	;CMD code
	and	al,al
	jz	DoReqInit
	cmp	al,8
	jc	I_BadCmd
	cmp	al,0Dh
	jnc	I_Removable
	cmp	al,0Ah
	jz	DoReqStatus
	cmp	al,0Bh
	jz	DoReqStatus
	jmp	DoReqOutput

I_Removable:
	mov	dx,MDevClose-Start
	cmp	al,0Eh
	jz	I_Close
	jnc	I_BadCmd
	mov	dx,MDevOpen-Start
I_Close:	mov	ax,MDAStringZ
	int	10h
DoReqStatus:	xor	al,al
	jmp	ReqReturn

I_BadCmd:	mov	al,3	;Unknown command
ReqReturn:	mov	ah,81h
	and	al,al
	jnz	I_SomeError
	mov	ah,01h
I_SomeError:	mov	word ptr es:[bx+3],ax

	pop	ax
	pop	bx
	pop	cx
	pop	dx
	pop	di
	pop	si
	pop	bp
	pop	ds
	pop	es
	retf

DoReqInit:
	cmp	byte ptr [FlagInit],0
	jnz	DRI_Ret
	mov	byte ptr [FlagInit],1

	mov	ax,0FFFFh
	mov	word ptr ds:[0],ax
	mov	word ptr ds:[2],ax

	push	es
	push	cs
	pop	es
	mov	si,EndProg-Start-2
	lea	di,EndProg-2
	mov	cx,(EndProg-ResResident+1)/2
	std
rep	movsw
	cld
	mov	byte ptr [AsDevice],1

	push	bx
	lea	dx,BannerM
	call	Print+100h
	xor	bx,bx
	mov	es,bx
	call	DeviceInst+100h
	pop	bx
	pop	es
	and	bp,bp
	jz	DRI_OkayInst
	xor	ax,ax
	mov	word ptr es:[bx+0Eh  ],ax
	mov	word ptr es:[bx+0Eh+2],ax
	inc	ax
	jmp	DRI_FailInit

DRI_OkayInst:	lea	dx,DeviceM
	call	Print+100h
DRI_Ret:	mov	word ptr es:[bx+0Eh  ],offset EndRes
	mov	word ptr es:[bx+0Eh+2],cs
	xor	ax,ax
DRI_FailInit:	mov	word ptr es:[bx+17h],ax
	xor	ax,ax
	mov	word ptr es:[bx+12h  ],ax	;BPB
	mov	word ptr es:[bx+12h+2],ax
	jmp	DoReqStatus

DoReqOutput:	lds	dx,es:[bx+0Eh]
	mov	cx,es:[bx+12h]
	mov	ax,MDAPutBlock
	int	10h
	jmp	DoReqStatus


ReqAddr	equ	$-100h
	org	$+4
FlagInit	equ	$-100h
	db	0

MDevOpen:	db	MDAPSPID,'Device open.',MDANL,MDAZ
MDevClose:	db	MDAPSPID,'Device close.',MDANL,MDAZ

ResResident:

Jump10:	cmp	ah,MDAMagic shr 8
	jne	JumpVect
	cmp	al,MDAUnused and 0FFh
	jnc	JumpVect

	cld

	push	ds
	push	es
	push	si
	push	di
	push	dx
	push	cx
	push	bx	;ON TOP!

	mov	bx,ax
	xor	bh,bh
	add	bx,bx
	call	word ptr cs:[FuncTable+bx]

	pop	bx
	pop	cx
	pop	dx
	pop	di
	pop	si
	pop	es
	pop	ds

	iret

JumpVect:	jmp	dword ptr cs:[OrigVect]

FuncTable:
	dw	offset FCheckInst
	dw	offset FWriteChar
	dw	offset FPutChar
	dw	offset FStringZ
	dw	offset FStringD
	dw	offset FInit
	dw	offset FStringAny
	dw	offset FModUseCnt
	dw	offset FPutBlock

FCheckInst:	push	bp
	mov	bp,sp
	mov	ax,cs
	mov	word ptr [bp+4],ax
	pop	bp
	mov	ax,MDAInstMagic
Return1:	ret

FModUseCnt:	add	dx,word ptr cs:[UseCount]
	mov	word ptr cs:[UseCount],dx
	mov	ax,dx
	ret

FWriteChar:	ifndef	USEPRT
	call	ISetup
	endif	;USEPRT
	call	IWriteChar
UpdateCursor:	ifndef	USEPRT
	push	ax
	shr	bx,1
	mov	ah,0Eh
	mov	al,bh
	call	OutByte
	inc	ah
	mov	al,bl
	call	OutByte
	pop	ax
	shl	bx,1
	mov	word ptr cs:[CursAddr],bx
	endif	;USEPRT
Return4:	ret

FPutBlock:	and	cx,cx
	jz	Return4
	push	ds
	pop	es
	mov	si,dx
	ifndef	USEPRT
	call	ISetup
	endif	;USEPRT
PutBlock_Loop:	mov	dl,es:[si]
	inc	si
	push	si
	push	cx
	call	IPutChar
	pop	cx
	pop	si
	loop	PutBlock_Loop
	jmp	UpdateCursor

IPutChar:	and	dl,dl	;MDAZ
	jz	Return1
	cmp	dl,MDAPSPID
	jne	IPC_1
	push	es
	les	si,dword ptr cs:[SafeAddr]
	mov	cx,es
	or	cx,si
	jz	IPC_FailSafe
	cmp	byte ptr es:[si],0
	jz	IPC_DosOkay
IPC_FailSafe:	pop	es
	ret

IPC_DosOkay:	mov	dl,'<'
	call	IWriteChar
	push	bx
	mov	ah,62h
	int	21h
	dec	bx
	mov	es,bx
	pop	bx
	mov	si,8
	mov	cx,8
IPC_LoopMCB:	mov	dl,es:[si]
	inc	si
	and	dl,dl
	jnz	IPC_NormChar
	dec	si
	mov	dl,' '
IPC_NormChar:	push	cx
	call	IWriteChar
	pop	cx
	loop	IPC_LoopMCB
	pop	es
	mov	dl,'>'
	jmp	IWriteChar

IPC_1:	cmp	dl,MDABELL
	jne	IPC_2
	ifndef	USEPRT
	mov	ax,0E07h
	mov	bl,MDAAttr	;Is this okay? Who cares...
	int	10h
	ret
	else	;USEPRT
	mov	dl,07h
	jmp	IWriteChar
	endif	;USEPRT

IPC_2:	cmp	dl,MDABS
	jne	IPC_6
	ifndef	USEPRT
	call	IDivBX
	and	ah,ah
	jz	Return2
	dec	bx
	dec	bx
	ret
	else	;USEPRT
	mov	dl,08h
	jmp	IWriteChar
	endif	;USEPRT

IPC_6:	cmp	dl,MDATAB
	jne	IPC_3
	ifndef	USEPRT
	add	bx,16
	db	81h,0E3h	;"and bx,not 15" - NOT ASSEMBLABLE IN TASM!
	dw	not 15
	jmp	ChkScrUp
	else	;USEPRT
	mov	dl,09h
	jmp	IWriteChar
	endif	;USEPRT

IPC_3:	cmp	dl,MDACR
	jne	IPC_4
	ifndef	USEPRT
IDoCR:	call	IDivBX
	mov	al,ah
	xor	ah,ah
	sub	bx,ax
Return2:	ret

IDivBX:	mov	ax,bx
	mov	cl,160
	div	cl
	ret
	else	;USEPRT
	mov	dl,0Dh
	jmp	IWriteChar
	endif	;USEPRT

IPC_4:	cmp	dl,MDANL
	jne	IPC_5
	ifndef	USEPRT
	add	bx,160
	call	IDoCR
	jmp	ChkScrUp
	else	;USEPRT
	mov	dl,0Dh
	call	IWriteChar
	mov	dl,0Ah
	jmp	IWriteChar
	endif	;USEPRT

IPC_5:	cmp	dl,MDACLEAR
	jne	IPC_7
	ifndef	USEPRT
	xor	bx,bx
	xor	di,di
	mov	cx,80*25*2/2
	mov	ax,' ' or (MDAAttr shl 8)
	push	es
	push	ds
	pop	es
rep	stosw
	pop	es
	ret
	else	;USEPRT
	mov	dl,0Ch
	;FALLTHRU
	endif	;USEPRT

IPC_7:
IWriteChar:	ifdef	USEPRT
	mov	al,dl
	mov	ah,00h
	push	dx
	xor	dx,dx
	int	17h
	; FIXME: errors ignored
	pop	dx
	else	;USEPRT
	mov	[bx],dl
	inc	bx
	inc	bx
ChkScrUp:	cmp	bx,80*25*2
	jc	Return2
ScrUp:	xor	di,di
	push	si
	mov	si,80*2
	mov	cx,80*(25-1)*2/2
	push	es
	push	ds
	pop	es
rep	movsw
	mov	cx,80*2/2
	mov	ax,' ' or (MDAAttr shl 8)
rep	stosw
	pop	es
	pop	si
	sub	bx,160
	endif	;USEPRT
	ret

FPutChar:	ifndef	USEPRT
	call	ISetup
	endif	;USEPRT
	call	IPutChar
UpdateCursS1:	jmp	UpdateCursor

FStringD:	mov	cl,'$'
	jmp	FStringAny

FStringZ:	mov	cl,MDAZ

FStringAny:	push	ds
	pop	es
	mov	si,dx
	ifndef	USEPRT
	call	ISetup
	endif	;USEPRT
StringAny_Loop:	mov	al,es:[si]
	cmp	al,cl
	je	UpdateCursS1
	push	si
	push	cx
	mov	dl,al
	call	IPutChar
	pop	cx
	pop	si
	inc	si
	jmp	StringAny_Loop

FInit:
	ifndef	USEPRT
	push	cs
	pop	ds
	mov	ah,SyncDataAS
	lea	si,SyncData
Init_OLoop:	lodsb
	call	OutByte
	je	Init_OOkay
	cmp	ah,0Ch
	jnc	Init_Bad
Init_OOkay:	inc	ah
	cmp	ah,SyncDataAE
	jne	Init_OLoop

	mov	ax,VSEG
	mov	es,ax
	xor	di,di
	mov	cx,80*25*2/2
	push	cx
	mov	ax,' ' or (MDAAttr shl 8)
rep	stosw
	xor	di,di
	pop	cx
repe	scasw		;EQ!
	jne	Init_Bad
	endif	;USEPRT

	lea	dx,BannerM
	mov	ax,MDAStringD
	int	10h
	mov	al,MDAOkay
	ret

	ifndef	USEPRT
Init_Bad:	mov	al,MDAError
	ret

;I: AH=Index, AL=Value; O: EQ=Okay
OutByte:	push	dx
	ifndef	USEVGA
	mov	dx,3B4h
	else
	mov	dx,3D4h
	endif
	xchg	ah,al
	out	dx,al
	xchg	ah,al
	inc	dx
	out	dx,al
	push	ax
	mov	ah,al
	in	al,080h
	in	al,dx
	cmp	ah,al
	pop	ax
	pop	dx
	ret
	endif

	ifndef	USEPRT
ISetup:	mov	ax,VSEG
	mov	ds,ax
	mov	bx,word ptr cs:[CursAddr]
	ret

SyncData:
	ifndef	NOSYNC
SyncDataAS	equ	0
	db	91,80,82, 5	;hTotal,hDisp,hSyncPos,hSyncWidth
	db	26, 0,25,25	;vTotalC,vTotalL,vDisp,vSync
	db	 2,15		;Interlace,MaxScanLine
	else
SyncDataAS	equ	10
	endif
	db	11,12		;CursorS,CursorE
	db	0,0		;MemoryMSB,MemoryLSB
	db	0,0		;CursorMSB,CursorLSB
SyncDataE:
SyncDataL	equ	SyncDataE-SyncData
SyncDataAE	equ	SyncDataAS+SyncDataL

CursAddr:	dw	0
	endif	;USEPRT
UseCount:	dw	0

BannerM:	db	'MDA Video BIOS extension v0.3'
	ifdef	USEPRT
	db	' [USEPRT]'
	else	;USEPRT
	ifdef	USEVGA
	db	' [USEVGA]'
	elseifdef NOSYNC
	db	' [NOSYNC]'
	endif	;NOSYNC
	endif	;USEPRT
	db	13,10,' - by Jan Kratochvil <short@ucw.cz> in 2005',13,10,13,10,'$'

AsDevice:	db	0
ManualDevice:	db	0
OrigVect:	org	$+4
SafeAddr:	org	$+4
EndRes:
	org	OrigVect
Install:        lea	dx,BannerM
	call	Print
	xor	bp,bp

	mov	ax,MDACheckInst
	int	10h
	cmp	ax,MDAInstMagic
	je	I_NoNewInst
NewInstS1:	jmp	NewInst

I_NoNewInst:
	mov	ds,bx
	cmp	byte ptr [AsDevice],0
	jz	NormDeInst
	mov	ah,34h	;Get DOS Safe Flag
	int	21h
	cli
	mov	word ptr [SafeAddr  ],bx
	mov	word ptr [SafeAddr+2],es
	sti
	lea	dx,ReInitM
	jmp	Print

NormDeInst:	push	ds
	push	cs
	pop	ds
	xor	dx,dx
	mov	ax,MDAModUseCnt
	int	10h
	lea	dx,InUseM
	and	ax,ax
	jnz	BadBailOut
	pop	ds

;here may by jumped also from inside DeviceInst (bp==1 in such case)
DoDeinstall:	call	GetIntVec
	mov	ax,es
	push	ds
	pop	cx
	cmp	ax,cx
	jne	BadVect
	cmp	bx,offset Jump10
	je	GoodVect
BadVect:	lea	dx,BadVectM
BadBailOut:	call	Print
	mov	ax,4C01h
	int	21h

GoodVect:	push	cs
	pop	ds
	and	bp,bp
	jnz	GV_Bad1
	lea	dx,MDeInstM
	call	StringZ
GV_Bad1:	lds	dx,dword ptr es:[OrigVect]
	call	SetIntVec
	lea	dx,ErrorMDAM
	and	bp,bp
	jnz	Print

	cmp	byte ptr es:[ManualDevice],0
	jz	GV_NoDevInst
	push	es		;SAVE resident segment
	mov	cx,es		;find this segment
	add	cx,0100h/10h
	push	cx		;SAVE device-based resident segment
	call	DeviceLister
	lea	dx,BadDevUnInstM
	push	offset GV_NoDevInst
	jnc	Print
	pop	ax	;drop
;we have found the device, unlink it:
	push	ds
	pop	es	;ES=foreign vector segment (& DI=foreign vector offset)
	pop	ds	;RESTORE DS=device-based resident segment
	xor	si,si
	cli
	movsw
	movsw
	sti
	pop	es	;RESTORE: ES=resident segment

GV_NoDevInst:	mov	ax,es
	dec	ax
	mov	ds,ax
	push	cs
	pop	ax
	mov	word ptr ds:[1],ax	;set us as the owner of resident's MCB
	mov	ah,49h
	int	21h	;Free
	lea	dx,GoodVectM
Print:	push	cs
	pop	ds
	mov	ah,9
	int	21h
	ret

NewInst:	mov	ax,word ptr ds:[2Ch]
	mov	es,ax
	mov	ah,49h
	int	21h	;Free
	mov	word ptr ds:[2Ch],0
	mov	ah,34h	;Get DOS Safe Flag
	int	21h
	call	DeviceInst
	and	bp,bp
	jnz	Return5

;Now try to add device device handler:
	mov	word ptr cs:[0100h],0FFFFh	;terminate our handler
	xor	cx,cx		;disable compare-functionality
	call	DeviceLister
	and	bx,bx
	jnz	NI_ListEnd
;failed on 0000/0000 entry
	lea	dx,BadDevNewInstM
	call	Print
	jmp	NI_StayResident

NI_ListEnd:
	inc	byte ptr cs:[ManualDevice]
	push	ds
	pop	es
	cli
	stosw	;store offset 0
	mov	ax,cs
	add	ax,0100h/10h
	stosw
	sti
;device handler is installed here
NI_StayResident:
	mov	dx,(EndRes-Start+10Fh)/16
	mov	ax,3100h
	int	21h



;returns: CY==1 && BX==CX on CX match, CY=0 && BX==0 on 0000/0000, CY=0 && BX!=0 on ListEnd
DeviceLister:
	push	cx
	mov	ax,122Ch	;device handler list -> BX:AX, *undocumented*
	int	2Fh
	pop	cx
	cld	; sanity
		; WARNING!: INT 2F/122C above have DESTROYED our %DS!

DL_Loop:	mov	ds,bx
	or	bx,ax		;clears CY!
	jz	Return5		;0000/0000 entry
	mov	si,ax
	mov	di,ax
	lodsw
	inc	ax
	jz	Return5		;ListEnd	(CY==0)
	dec	ax
	mov	bx,word ptr ds:[si]
	jnz	DL_Loop		;we require offset==0 on CX match
	cmp	bx,cx
	jnz	DL_Loop
	stc
Return5:	ret

DeviceInst:	push	es
	push	bx
	call	GetIntVec
	lea	di,OrigVect
	mov	ax,es
	xchg	ax,bx
	push	ds
	pop	es
	stosw
	mov	ax,bx
	stosw
	pop	ax
	stosw	;Offs
	pop	ax
	stosw	;Seg
	lea	dx,Jump10
	call	SetIntVec
	mov	ax,MDAInit
	int	10h
	mov	bp,1
	and	al,al
	jnz	DoDeinstallS1
	dec	bp
	lea	dx,NewInstM
	call	Print
	lea	dx,MInstM
StringZ:	mov	ax,MDAStringZ
	int	10h
Return3:	ret

;INT21/3510-like but device safe
GetIntVec:	xor	bx,bx
	mov	es,bx
	cli
	mov	bx,word ptr es:[10h*4  ]
	mov	es,word ptr es:[10h*4+2]
	sti
	ret
;INT21/2510-like but device safe
SetIntVec:	xor	ax,ax
	push	es
	mov	es,ax
	mov	ax,ds
	cli
	mov	word ptr es:[10h*4  ],dx
	mov	word ptr es:[10h*4+2],ax
	sti
	pop	es
	ret

DoDeinstallS1:	jmp	DoDeinstall

ErrorMDAM:	db	'MDA failed to initialize - check HW and memory managers!',13,10,'$'
NewInstM:	db	'MDA initialized and resident part installed.',13,10,'$'
BadDevNewInstM:	db	'WARNING: Runtime (no config.sys) device installation failed!',13,10,'$'
BadDevUnInstM:	db	'ERROR: Unable to deinstall runtime-installed device!',13,10,'$'
DeviceM:	db	'Device-type install passed, EXEC re-init needed for PSP ID.',13,10,'$'
BadVectM:	db	'Cannot deinstall, vectors stolen!',13,10,'$'
GoodVectM:	db	'Successful deinstallation.',13,10,'$'
InUseM:	db	'MDA BIOS in use - deinstall not allowed!',13,10,'$'
ReInitM:	db	'Installed device reinitialized for PSP ID.',13,10,'$'

MDeInstM:	db	MDAPSPID,'Deinstalling MDA BIOS...',MDANL,MDAZ
MInstM:	db	MDAPSPID,'Successfully initialized and staying resident.',MDANL,MDAZ

EndProg:
	end	Start
